/* Tecnisa - Tecnologia em Informtica

Nome: 9003_CTBSTP_ATUALIZA_SALDO_CONTABIL.SQL

Descrio:
 Procedimento para atualizao do saldo contbil (VRLANCTOEST).

Criao:
__/__/__ - ______________________________

Manutenes:
23/11/99 Paulo Giovanni - Converso p/ SQL-SERVER
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
*/

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'ATUALIZA_SALDO_CONTABIL' AND type = 'P')
  DROP PROCEDURE ATUALIZA_SALDO_CONTABIL
  GO

CREATE PROCEDURE ATUALIZA_SALDO_CONTABIL
	              @P_CDEMPRESA VARCHAR(2)

AS
DECLARE @V_TESTADIA     DATETIME;

DECLARE @V_DTFINACONT   DATETIME;
DECLARE @DATA_SALDO     DATETIME;
DECLARE @V_DATAINIC     DATETIME;
DECLARE @V_CONTSALDO    VARCHAR(1);
DECLARE @V_IDSALDEMPR   VARCHAR(1);
DECLARE @V_SEMSALDO     VARCHAR(1);

/*INCIO DAS VARIVEIS DO CURSOR C_LANCCTBL*/
DECLARE @V_CDEMPRESA_A varchar(2);
DECLARE @V_CDCONTCTBL  varchar(20);
DECLARE @V_IDLANCSALDO varchar(1);
DECLARE @V_VRLANCAMENT numeric(16,2);
DECLARE @V_CDEMPRESA varchar(2);
DECLARE @V_CDCONTCTBL_A varchar(20);
DECLARE @V_DTSALDEMPR datetime;
DECLARE @V_VRSALDEMPR numeric(16,2);
/*FIM DAS VARIVEIS DO CURSOR C_LANCCTBL*/

/*INCIO DAS VARIVEIS DO CURSOR C_LANCDEL*/
DECLARE @V_NRSEQLANEX  VARCHAR(10);
/*FIM DAS VARIVEIS DO CURSOR C_LANCDEL*/

/* VARIVEIS DO CURSOR SOMACONTA */
/*DECLARE @V_CDCONTCTBL varchar(20); */
DECLARE @V_VALORSALDO numeric(16,2);
/* FIM DO SOMACONTA */

BEGIN

      SELECT @V_DTFINACONT = MAX(DTFINACONT)
      FROM CONTOPECTBL
      WHERE CDEMPRESA = @P_CDEMPRESA;

      IF @V_DTFINACONT IS NULL
      BEGIN
         RAISERROR('Perodo contbil no cadastrado.', 16,1);
      END ;

        SELECT @V_DATAINIC = MIN(DTLANCCONT)
          FROM LANCCONT, CONTCTBL
         WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA) 
           AND (LANCCONT.IDLANCSALDO = 'N') 
           AND (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL) 
           AND (CONTCTBL.IDCONTCCUS <> 'R');
                      
        IF @V_DATAINIC IS NULL BEGIN
           SELECT @V_DATAINIC = MIN(DTLANCCONCOM)
           FROM LANCOMEEX, CONTCTBL
           WHERE (CDEMPRESA = @P_CDEMPRESA) AND
                 (LANCOMEEX.CDCONTALACOM = CONTCTBL.CDCONTCTBL) AND
                 (CONTCTBL.IDCONTCCUS <> 'R');
        END;

      DECLARE C_LANCCTBL CURSOR FOR
      SELECT LANCCONT.CDEMPRESA,LANCCONT.CDCONTCTBL,IDLANCSALDO,VRLANCAMENT,
             SALDEMPR.CDEMPRESA, SALDEMPR.CDCONTCTBL,DTSALDEMPR,VRSALDEMPR
        FROM LANCCONT, SALDEMPR, CONTCTBL WITH (UPDLOCK)
       WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA)
         AND (LANCCONT.IDLANCSALDO = 'N')
         AND (SALDEMPR.CDEMPRESA   = @P_CDEMPRESA)
         AND (LANCCONT.CDCONTCTBL  = SALDEMPR.CDCONTCTBL)
         AND (SALDEMPR.DTSALDEMPR BETWEEN @V_DATAINIC AND @V_DTFINACONT)
         AND (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL) 
         AND (IDCONTCCUS <> 'R')

      OPEN  C_LANCCTBL;
      CLOSE C_LANCCTBL;

      DECLARE C_LANCDEL CURSOR FOR
      SELECT NRSEQLANEX
        FROM LANCONTEX
       WHERE (CDEMPRESA = @P_CDEMPRESA) AND
             (DTLANCCONEX BETWEEN @V_DATAINIC AND @V_DTFINACONT)
                                    
      OPEN  C_LANCDEL;
      CLOSE C_LANCDEL;

      /* FOI RETIRADO DAQUI O @DATA_SALDO = LAST_DAY(@V_DATAINIC)*/
      SET @DATA_SALDO = @V_DATAINIC;
      EXEC ULTIMO_DIA_MES @P_DTDATA = @DATA_SALDO OUTPUT;

   WHILE (@DATA_SALDO <= @V_DTFINACONT)
   BEGIN

      DECLARE SOMACONTA CURSOR FOR
      SELECT LANCCONT.CDCONTCTBL, SUM(LANCCONT.VRLANCAMENT) AS VALORSALDO
       FROM LANCCONT, CONTCTBL
       WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA)                     AND
             (LANCCONT.IDLANCSALDO = 'N')                              AND
             (LANCCONT.DTLANCCONT BETWEEN @V_DATAINIC AND @DATA_SALDO) AND
             (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL)               AND
             (CONTCTBL.IDCONTCCUS <> 'R')
       GROUP BY LANCCONT.CDCONTCTBL
       UNION ALL
       SELECT LANCONTEX.CDCONTALAEX AS CDCONTCTBL, SUM(VRLANCCONEX) AS VALORSALDO
         FROM LANCONTEX, CONTCTBL
        WHERE (CDEMPRESA = @P_CDEMPRESA) AND
              (DTLANCCONEX BETWEEN @V_DATAINIC AND @DATA_SALDO) AND
              (LANCONTEX.CDCONTALAEX = CONTCTBL.CDCONTCTBL) AND
              (CONTCTBL.IDCONTCCUS <> 'R')
        GROUP BY CDCONTALAEX;

       OPEN SOMACONTA;
       FETCH NEXT FROM SOMACONTA INTO @V_CDCONTCTBL,@V_VALORSALDO ;

      WHILE (@@FETCH_STATUS = 0 )
      BEGIN
         SELECT @V_SEMSALDO = COUNT(*)
         FROM SALDEMPR
         WHERE (CDEMPRESA  = @P_CDEMPRESA) AND
               (CDCONTCTBL = @V_CDCONTCTBL) AND
               (DTSALDEMPR = @DATA_SALDO);

         IF @V_SEMSALDO = 0
         BEGIN
            INSERT INTO SALDEMPR
            (CDEMPRESA, CDCONTCTBL, DTSALDEMPR, VRSALDEMPR)
            (SELECT @P_CDEMPRESA, CDCONTCTBL, @DATA_SALDO, 0
             FROM CONTCTBL
             WHERE (CdContCtbl NOT IN (SELECT DISTINCT CdContCtbl
                                       FROM SALDEMPR
                                       WHERE ((CDEMPRESA  = @P_CDEMPRESA)    AND
                                              (DTSALDEMPR  = @DATA_SALDO)))) AND
                    (CHARINDEX(RTRIM(CONTCTBL.CDCONTCTBL), @V_CDCONTCTBL) = 1));

         END;

	      UPDATE SALDEMPR SET VRSALDEMPR = SALDEMPR.VRSALDEMPR + @V_VALORSALDO
		   WHERE (SALDEMPR.DTSALDEMPR = @DATA_SALDO) AND
               (SALDEMPR.CDEMPRESA  = @P_CDEMPRESA) AND
		         (CHARINDEX(RTRIM(SALDEMPR.CDCONTCTBL), @V_CDCONTCTBL) = 1);

      END ;   /* END DO WHILE DO CURSOR*/

      CLOSE SOMACONTA;
      DEALLOCATE SOMACONTA;
      DEALLOCATE C_LANCCTBL;

      SET @DATA_SALDO = DATEADD(MM, 1, @DATA_SALDO);

	END;
	UPDATE LANCCONT SET IDLANCSALDO = 'S'
	WHERE (CDEMPRESA   = @P_CDEMPRESA) AND
         (IDLANCSALDO = 'N') ;
END;
GO